package flips

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/constants"
	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DeleteRequest to delete a floating ip
type DeleteRequest struct {
	// ID of a floating IP
	// Required: true
	FloatingIPID string `url:"floating_ip_id" json:"floating_ip_id" validate:"required"`

	// Version ID
	// Required: true
	VersionID uint64 `url:"version_id" json:"version_id" validate:"required"`

	// Force delete
	// Required: false
	Force bool `url:"force,omitempty" json:"force,omitempty"`
}

// Delete a floating ip
func (fi FloatingIPs) Delete(ctx context.Context, req DeleteRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/sdn/floating_ip/delete"

	res, err := fi.client.DecortApiCallCtype(ctx, http.MethodDelete, url, constants.MIMEJSON, req)
	if err != nil {
		return false, err
	}

	if string(res) == "" {
		return true, nil
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}
